package com.fr.plugin.bi.fusion.web;

import com.finebi.foundation.api.web.component.AssembleComponentFactory;
import com.fr.decision.fun.impl.AbstractWebResourceProvider;
import com.fr.decision.webservice.v10.user.UserService;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.web.struct.Atom;
import com.fr.web.struct.Component;
import com.fr.web.struct.browser.RequestClient;
import com.fr.web.struct.category.ParserType;
import com.fr.web.struct.category.ScriptPath;
import com.fr.web.struct.category.StylePath;

/**
 * @Author ezreal
 * @Date 2023/5/8 11:17
 * @Version 10.0
 */
@FunctionRecorder
public class DecisionWebBridge extends AbstractWebResourceProvider {
    @Override
    public Atom attach() {
        return AssembleComponentFactory.getBusinessConfigureComponent();
    }

    @Override
    public Atom client() {
        return new Component() {
            @Override
            public ScriptPath script(RequestClient req) {
                return ScriptPath.build("com/fr/plugin/bi/mix/web/js/decision/fr.mix.bi.decision.min.js", ParserType.DYNAMIC);
            }
            @Override
            public StylePath style(RequestClient req) {
                return StylePath.build("com/fr/plugin/bi/web/css/iconfont.css",ParserType.DYNAMIC);
            }
        };
    }
}
