"use strict";

;
!function () {
  BI.Front = BI.Front || {};
  BI.Front = BI.extend(BI.Front, {
    SUPPORT_REPORT: [{
      typeValue: 101,
      type: "cpt",
      name: "cpt",
      suffix: ".cpt",
      iconCls: "fanruan-cpt-logo",
      text: "CPT报表",
      showPage: function showPage(id) {
        var params = BI.Router.$router.history.current.params;
        BI.Router.$router.push({
          name: "finereport_cpt",
          params: Object.assign(Object.assign({}, params), {
            id: id
          })
        });
      },
      route: {
        edit: {
          name: "finereport_cpt",
          // path: "/:subjectId/cpt/:id",
          path: "cpt/:id",
          //   path: "/:cpt",
          //    parent: parentRoute,
          children: [],
          components: {
            analysis: {
              type: "bi.subject.view.extend.report",
              reportType: "cpt"
            }
          },
          beforeEnter: function beforeEnter(to, _from, next) {
            next();
          }
        },
        view: {
          name: "finereport_cpt",
          path: "cpt/:id",
          //   path: "/:cpt",
          //    parent: parentRoute,
          children: [],
          components: {
            analysis: {
              type: "bi.subject.view.extend.report",
              editable: false,
              reportType: "cpt"
            }
          }
        }
      },
      addAction: function addAction() {
        BI.Msg.prompt("新增cpt报表", "输入名称", function (value) {
          if (BI.isKey(value.name)) {
            BI.Front.subject_view.store.addExtendReport(value);
          } else {
            BI.Msg.toast("名称为空", {
              level: "error"
            });
          }
        }, {
          type: "bi.subject.report.cpt.add.pop",
          width: 300
        }, function (value) {
          return BI.Front.subject_view.store.checkReportName(value);
        });
      },
      paneType: {
        tab: "bi.subject.tab.extend.report.item"
      }
    }, {
      type: "frm",
      typeValue: 102,
      name: "frm",
      suffix: ".frm",
      iconCls: "fanruan-frm-logo",
      text: "决策报表",
      showPage: function showPage(id) {
        var params = BI.Router.$router.history.current.params;
        BI.Router.$router.push({
          name: "finereport_frm",
          params: Object.assign(Object.assign({}, params), {
            id: id
          })
        });
      },
      addAction: function addAction() {
        BI.Msg.prompt("新增决策报表", "输入名称", function (value) {
          if (BI.isKey(value)) {
            BI.Front.subject_view.store.addExtendReport({
              name: value,
              type: 102
            });
          } else {
            BI.Msg.toast("名称为空", {
              level: "error"
            });
          }
        }, {}, function (value) {
          return BI.Front.subject_view.store.checkReportName({
            name: value,
            type: 102
          });
        });
      },
      route: {
        edit: {
          name: "finereport_frm",
          //   path: "/:subjectId/frm/:id",
          path: "frm/:id",
          //   path: "/:cpt",
          //    parent: parentRoute,
          children: [],
          components: {
            analysis: {
              type: "bi.subject.view.extend.report",
              reportType: "frm"
            }
          },
          beforeEnter: function beforeEnter(to, _from, next) {
            next();
          }
        },
        view: {
          name: "finereport_frm",
          path: "frm/:id",
          //   path: "/:cpt",
          //    parent: parentRoute,
          children: [],
          components: {
            analysis: {
              type: "bi.subject.view.extend.report",
              editable: false,
              reportType: "frm"
            }
          }
        }
      },
      paneType: {
        tab: "bi.subject.tab.extend.report.item"
      }
    }],
    showReportPage: function showReportPage(reportId, reportType) {
      var find = BI.find(BI.Front.SUPPORT_REPORT, function (index, o) {
        return o.type === reportType || o.typeValue === reportType;
      });
      if (find) {
        find.showPage(reportId);
      }
    }
  });
  BI.Front.Constants = BI.Front.Constants || {};
}();
/**
 * 对bi.subject.tab的魔改
 */
;
!function () {
  /**
   * 新增下面tab栏的图标
   * important
   */
  BI.Plugin.configRender("bi.subject.tab", function (renderObj) {
    try {
      /**
       * 可以修改render方法返回的json对象
       * important
       */
      var tabWidget = renderObj.items[1];
      var columnSize = tabWidget.columnSize;
      if (columnSize) {
        var width = columnSize[columnSize.length - 1] + 88;
        columnSize[columnSize.length - 1] = width;
        renderObj.items[1].items[2].width = width;
      }
      //  var columnSize = renderObj.columnSize;
      //   columnSize[columnSize.length - 1] = columnSize[columnSize.length - 1] + 40;
      var items = renderObj.items[1].items[2].items;
      /*var x = BI.deepClone(items[1]);
      x.title = "新增复杂报表";*/
      BI.each(BI.Front.SUPPORT_REPORT, function (index, item) {
        items.push({
          type: "bi.icon_button",
          cls: item.iconCls,
          forceNotSelected: true,
          height: 16,
          iconHeight: 16,
          iconWidth: 16,
          title: "新增" + item.text,
          width: 32,
          handler: function handler() {
            BI.isFunction(item.addAction) && item.addAction();
          }
        });
      });
    } catch (e) {}
    return renderObj;
  });
}();
/**
 * 对bi.subject.view组件的一些魔改
 */
;
!function () {
  BI.Front = BI.Front || {};
  BI.Front = BI.extend(BI.Front, {
    subject_view: {
      store: null,
      model: null
    }
  });
  BI.Plugin.registerWidget("bi.subject.view", function (widget) {
    widget.beforeInit = function (callback) {
      var self = this;
      var service = BI.Services.getService("subject.report.service");
      BI.Front.subject_view.store = self.store;
      BI.Front.subject_view.model = self.model;
      self.store.getExtendReportItem = function (item, type) {
        var find = BI.find(BI.Front.SUPPORT_REPORT, function (index, o) {
          return o.type === type || o.typeValue === type;
        });
        if (find) {
          return {
            type: find.paneType.tab,
            id: item.id,
            name: item.name,
            report: item,
            reportType: find.type,
            iconCls: find.iconCls,
            onSelect: function onSelect() {
              BI.Front.showReportPage(item.id, find.type);
            },
            listeners: [{
              eventName: "DELETE",
              action: function action(id) {
                self.store.deleteExtendReport(id);
              }
            }, {
              eventName: "EVENT_REFRESH",
              action: function action() {
                self.store.refreshTab();
              }
            }],
            editable: self.options.subjectEntryType == 0
          };
        }
        return {
          type: "bi.label",
          text: item.name
        };
      };
      self.store.addExtendReport = function (data) {
        service.subjectAddReport(BI.Router.$router.history.current.params.subjectId, data, function (res) {
          if (res.data) {
            var order = self.model.customOrder.slice();
            order.push(res.data.id);
            self.store.sortLabels(order).then(function () {
              self.store.refreshTab().then(function () {
                BI.Front.showReportPage(res.data.id, data.type);
              });
            });
          } else if (res.errorCode) {
            BI.Msg.toast(res.errorMsg, {
              level: "error"
            });
          }
        });
      };
      self.store.deleteExtendReport = function (id) {
        service.deleteSubjectReport(self.model.subjectInfo.id, id, function (res) {
          if (res.data && res.data.errorCode) {
            if (res.data.errorCode == "61600003") {
              BI.Msg.toast("已发布模板无法删除", {
                level: "error"
              });
            } else {
              BI.Msg.toast("删除报错", {
                level: "error"
              });
            }
            return;
          }
          self.store.refreshTab(id);
        });
      };
      self.store.checkReportName = function (value) {
        var self = this;
        var reportItems = [];
        if (value.type === 101) {
          reportItems = self.model.subjectInfo.cptItems.availableReports;
        } else if (value.type === 102) {
          reportItems = self.model.subjectInfo.frmItems.availableReports;
        }
        var find = BI.find(reportItems, function (i, item) {
          return item.name == value.name;
        });
        if (find) {
          BI.Msg.toast("同类报表名称不能重复", {
            level: "error"
          });
          return false;
        }
        return true;
      };
      /*            /!**
                   * 初始化
                   *!/
                  BI.each(self.model.subjectInfo.cptItems.availableReports, function (index, o) {
                      self.model.labels.push(self.store.getExtendReportItem(o, "cpt"));
                  });
                  BI.each(self.model.subjectInfo.frmItems.availableReports, function (index, o) {
                      self.model.labels.push(self.store.getExtendReportItem(o, "frm"));
                  });
                  const order = self.model.customOrder;
                  if (BI.isEmptyArray(order)) {
                      self.model.sortLabels = self.model.labels;
                  } else {
                      self.model.sortLabels = self.model.labels.sort(function (a, b) {
                          return order.indexOf(a.id) - order.indexOf(b.id);
                      })
                  }*/
      BI.Front.utils.injectionFunc(self.store._computedWatchers.labels, [{
        functionName: "getter",
        returnValue: true,
        afterFunc: function afterFunc(oldLabel) {
          BI.each(self.model.subjectInfo.cptItems.availableReports, function (index, o) {
            var find = BI.find(oldLabel, function (i, label) {
              return o.id === label.id;
            });
            if (!find) {
              oldLabel.push(self.store.getExtendReportItem(o, "cpt"));
            }
          });
          BI.each(self.model.subjectInfo.frmItems.availableReports, function (index, o) {
            var find = BI.find(oldLabel, function (i, label) {
              return o.id === label.id;
            });
            if (!find) {
              oldLabel.push(self.store.getExtendReportItem(o, "frm"));
            }
          });
          return oldLabel;
        }
      }]);
      BI.Front.utils.injectionFunc(self.store, [{
        functionName: "refreshTab",
        afterFunc: function afterFunc(value, id) {
          if (BI.isNotNull(id)) {
            return this.updateSubjectInfo();
          }
          return value;
        },
        returnValue: true
      }]);
      // self.store.updateSubjectInfo();
      BI.isFunction(callback) && callback();
    };
  });
}();
;
!function () {
  BI.Front = BI.Front || {};
  BI.Front = BI.extend(BI.Front, {
    utils: {
      injectionFunc: function injectionFunc(o, configs) {
        if (BI.isNotEmptyArray(configs)) {
          BI.each(configs, function (index, item) {
            var functionName = item.functionName;
            if (functionName) {
              var oldFunction = o[functionName];
              var beforeFunc = item.beforeFunc; //执行前的函数
              var afterFunc = item.afterFunc; //执行后函数
              var returnValue = item.returnValue; //是否返回值
              var replaceFunc = item.replaceFunc; //替换函数，如果不传递那么就会执行下默认的

              o[functionName] = function () {
                var para = [];
                var len = arguments.length;
                for (var i = 0; i < len; i++) {
                  para.push(arguments[i]);
                }
                if (BI.isFunction(beforeFunc)) {
                  beforeFunc.apply(o, para);
                }
                if (returnValue) {
                  var value = null;
                  if (BI.isFunction(replaceFunc)) {
                    value = replaceFunc.apply(o, para);
                  } else {
                    value = oldFunction.apply(o, para);
                  }
                  if (BI.isFunction(afterFunc)) {
                    para.unshift(value);
                    value = afterFunc.apply(o, para);
                  }
                  return value;
                } else {
                  if (BI.isFunction(replaceFunc)) {
                    replaceFunc.apply(o, para);
                  } else {
                    oldFunction.apply(o, para);
                  }
                  if (BI.isFunction(afterFunc)) {
                    afterFunc.apply(o, para);
                  }
                }
              };
            }
          });
        }
      }
    }
  });
  $.extend(BI.Msg, {
    /**
     * 弹出框然后有个输入，确认返回输入的值
     * @param title 标题
     * @param content 标签
     * @param callback 回调函数
     * @param validationChecker 文本框的校验
     */
    prompt: function prompt(title, content, callback, config, checkFunc) {
      //    BI.Popovers.removeAll();
      var id = BI.UUID();
      var textEditor = {
        type: "bi.text_editor",
        ref: function ref(_ref) {
          BI[id] = _ref;
        },
        width: 200
      };
      textEditor = BI.extend(textEditor, config ? config : {});
      var widget = BI.Popovers.create(id, {
        type: "bi.bar_popover",
        // String或者是json都行
        header: title,
        size: "small",
        body: {
          type: "bi.horizontal",
          horizontalAlign: "center",
          verticalAlign: "middle",
          hgap: 10,
          items: [{
            type: "bi.label",
            text: content
          }, textEditor]
        },
        footer: {
          type: "bi.right_vertical_adapt",
          lgap: 10,
          items: [{
            type: "bi.button",
            text: "取消",
            value: 1,
            level: "ignore",
            handler: function handler(v) {
              BI.Popovers.remove(id);
            }
          }, {
            type: "bi.button",
            text: "确定",
            value: 0,
            handler: function handler(v) {
              var value = BI[id].getValue();
              if (BI.isFunction(checkFunc) && !checkFunc(value)) {
                return;
              }
              BI.isFunction(callback) && callback(BI[id].getValue());
              BI.Popovers.remove(id);
            }
          }]
        }
        /*    listeners: [{
                eventName: "EVENT_CANCEL",
                action: function () {
                 }
            }, {
                eventName: "EVENT_CONFIRM",
                action: function () {
                    BI.isFunction(callback) && callback(BI[id].getValue());
                }
            }]*/
      });

      widget.show(id);
    }
  });
}();
;
!function () {
  var widget = BI.inherit(BI.Widget, {
    props: {},
    watch: {},
    /*        _store: function () {
                return BI.Models.getModel("");
            },*/
    beforeInit: function beforeInit(callback) {
      callback();
    },
    render: function render() {
      var self = this;
      return {
        type: "bi.horizontal",
        //       horizontalAlign: "center",
        verticalAlign: "middle",
        items: [{
          el: {
            type: "bi.text_editor",
            ref: function ref(_ref) {
              self.textEditor = _ref;
            },
            width: 100
          }
        }, {
          el: {
            type: "bi.label",
            text: "预览类型"
          },
          lgap: 10
        }, {
          el: {
            type: "bi.text_value_combo",
            width: 100,
            value: "page",
            ref: function ref(_ref) {
              self.previewModel = _ref;
            },
            items: [{
              value: "page",
              text: "分页预览"
            }, {
              value: "write",
              text: "填报预览"
            }]
          },
          lgap: 10
        }]
      };
    },
    mounted: function mounted() {},
    getValue: function getValue() {
      return {
        type: 101,
        name: this.textEditor.getValue(),
        op: this.previewModel.getValue()[0]
      };
    }
  });
  BI.shortcut("bi.subject.report.cpt.add.pop", widget);
}();
;
!function () {
  var CLIENTID = "e43e37dd7794460f8f81731eda84b2d8";
  var SECRET = "3429e051e025412d8426bcf30d60b2cb";
  var Service = BI.inherit(BI.OB, {
    /**
     * 增加主题的报表
     * @param subjectId
     * @param data
     * @param callback
     */
    subjectAddReport: function subjectAddReport(subjectId, data, callback) {
      BI.CLI.template.add(subjectId, data, callback);
    },
    getSubjectReport: function getSubjectReport(subjectid) {
      var url = "/front/subject/report?subjectid=" + subjectid;
      var result = {};
      Dec.syncAjax({
        type: "GET",
        url: url,
        success: function success(res) {
          result = res;
        }
      });
      return Promise.resolve(result);
    },
    deleteSubjectReport: function deleteSubjectReport(subjectId, reportId, callback) {
      BI.CLI.template["delete"](subjectId, reportId, callback);
    },
    /**
     * 在线打开设计器
     */
    openDesigner: function openDesigner(callback) {
      var url = "/wakeup/plugin/token";
      Dec.reqPost(url, "", callback);
    }
  });
  BI.service("subject.report.service", Service);
}();
/**
 * finereport的tab组件
 */
;
!function () {
  var widget = BI.inherit(BI.BasicButton, {
    props: {
      baseCls: 'bi-subject-tab-report-item',
      report: {},
      height: 30,
      editable: true,
      showCombo: true,
      allowRename: true,
      reportType: "cpt",
      forceSelected: true,
      showChecker: function showChecker() {
        return false;
      },
      showValueItems: [1, 7, 21, 22, 445]
    },
    watch: {
      name: function name(v) {
        this.textEditor.setValue(v);
      }
    },
    _store: function _store() {
      return BI.Models.getModel("bi.subject.tab.extend.report.item.model", {
        id: this.options.id,
        name: this.options.name,
        reportType: this.options.reportType,
        report: this.options.report
      });
    },
    beforeInit: function beforeInit(callback) {
      this.store.initData(callback);
    },
    render: function render() {
      var self = this,
        o = this.options;
      return {
        type: "bi.vertical_adapt",
        cls: "bi-hover-visible-container",
        columnSize: [16, "fill", ""],
        items: [{
          el: {
            type: "bi.icon_label",
            cls: o.iconCls,
            height: 16,
            iconHeight: 16,
            iconWidth: 16
          },
          lgap: 6
        }, self._createShowTextWidget(), self._createToolCombo()]
      };
    },
    _createShowTextWidget: function _createShowTextWidget() {
      var _this$options = this.options,
        height = _this$options.height,
        editable = _this$options.editable,
        allowRename = _this$options.allowRename,
        id = _this$options.id,
        name = _this$options.name;
      var self = this;
      if (editable && allowRename) {
        return {
          type: "bi.shelter_editor",
          hgap: 2,
          // stopPropagation: true,
          height: 20,
          textAlign: "left",
          allowBlank: false,
          cls: "label-text",
          errorText: function errorText(e) {
            return "" === e ? "报表名称不能为空" : "报表名称不能重复";
            //     return BI.i18nText("" === e ? "BI-Conf_Widget_Name_Cannot_Empty" : "BI-Conf_Widget_Name_Cannot_Repeat")
          },

          validationChecker: function validationChecker(v) {
            var id = self.model.namesMap[v];
            if (!id) {
              return true;
            }
            return false;
          },
          ref: function ref(_ref) {
            self.textEditor = _ref;
          },
          value: name,
          listeners: [{
            eventName: "EVENT_CONFIRM",
            action: function action() {
              var text = self.textEditor.getValue();
              if (self.model.name !== text) {
                self.store.reNameReport(text);
              }
            }
          }]
        };
      }
      return {
        type: "bi.label",
        text: name,
        height: 20,
        _hgap: 4,
        textAlign: 'left',
        cls: "tab-item-text"
      };
    },
    _createToolCombo: function _createToolCombo() {
      var _this$options2 = this.options,
        editable = _this$options2.editable,
        showChecker = _this$options2.showChecker,
        showCombo = _this$options2.showCombo,
        id = _this$options2.id;
      var self = this;
      if (editable && showCombo) {
        return {
          el: {
            type: "bi.down_list_combo",
            stopPropagation: true,
            invisible: false,
            cls: "tab-item-hover-active bi-hover-visible-item",
            iconCls: "vertical-more-item-font",
            el: {
              type: "bi.icon_trigger"
            },
            height: 24,
            width: 24,
            ref: function ref(_ref) {
              self.setting = _ref;
            },
            listeners: [{
              eventName: "EVENT_BEFORE_POPUPVIEW",
              action: function action() {
                self.setting.populate(self.createItems());
                self.setting.adjustWidth();
                self.setting.adjustHeight();
              }
            }, {
              eventName: "EVENT_CHANGE",
              action: BI.bind(self.operator, self)
            }]
          },
          rgap: 6
        };
      }
      return {
        el: {
          type: "bi.label",
          text: ""
        },
        rgap: 8
      };
    },
    createItems: function createItems() {
      var self = this;
      var items = BI.deepClone(BI.Providers.getProvider("bi.provider.conf.list.report.item").getItems());
      var toolItems = [];
      var showValueItems = this.options.showValueItems;
      BI.each(items, function (i, groupItems) {
        var itemArr = [];
        BI.each(groupItems, function (index, groupItem) {
          if (showValueItems.indexOf(groupItem.value) >= 0) {
            itemArr.push(BI.extend(groupItem, {
              invisible: function invisible() {
                return !self._isShow(groupItem.value, self.options.report);
              },
              reportInfoGetter: function reportInfoGetter() {
                return {
                  id: self.model.id,
                  name: self.model.name
                };
              },
              isOwn: true,
              refresh: function refresh() {
                self.fireEvent("EVENT_REFRESH", groupItem.value);
              }
            }));
          }
        });
        if (itemArr.length > 0) {
          toolItems.push(itemArr);
        }
      });
      return toolItems;
    },
    _isShow: function _isShow(itemValue, reportItem) {
      var self = this;
      if (itemValue === 21) {
        return reportItem.publishStatus == 0;
      }
      if (itemValue === 22) {
        return reportItem.publishStatus != 0;
      }
      return true;
    },
    focus: function focus() {
      this.textEditor.focus();
    },
    operator: function operator(v) {
      if (v == 7) {
        this.fireEvent("DELETE", this.options.id);
      }
      if (v == 1) {
        this.focus();
      }
    },
    mounted: function mounted() {}
  });
  BI.shortcut("bi.subject.tab.extend.report.item", widget);
}();
;
!function () {
  var store = BI.inherit(Fix.Model, {
    state: function state() {
      // const {params} = BI.Router.$router.history.current;
      return {
        id: this.options.id,
        name: this.options.name,
        reportType: this.options.reportType,
        report: this.options.report
      };
    },
    context: ['subjectInfo', 'tables', 'resourceOperationInfo'],
    childContext: [],
    computed: {
      reportItems: function reportItems() {
        var self = this;
        var reportItems = [];
        if (self.model.reportType === "cpt") {
          reportItems = self.model.subjectInfo.cptItems.availableReports;
        } else if (self.model.reportType === "frm") {
          reportItems = self.model.subjectInfo.frmItems.availableReports;
        }
        return reportItems;
      },
      namesMap: function namesMap() {
        var self = this;
        var namesMap = {};
        BI.each(self.model.reportItems, function (index, item) {
          if (item.id != self.model.id) {
            namesMap[item.name] = item.id;
          }
        });
        return namesMap;
      }
    },
    actions: {
      initData: function initData(callback) {
        var self = this;
        BI.isFunction(callback) && callback();
      },
      reNameReport: function reNameReport(newName) {
        var self = this;
        var oldName = self.model.name;
        self.model.name = newName;
        BI.CLI.template.rename(self.model.subjectInfo.id, {
          id: self.model.id,
          name: newName
        }, function (res) {
          if (res.errorCode) {
            BI.Msg.toast(res.errorMsg, {
              level: "error"
            });
            self.model.name = oldName;
            return;
          }
          self.model.report.name = newName;
        });
      }
    }
  });
  BI.model("bi.subject.tab.extend.report.item.model", store);
}();
/**
 * 展示cpt模板
 */
;
!function () {
  var RGAP = 15;
  BI.CPTVIEW = BI.inherit(BI.Widget, {
    props: {
      reportType: "cpt",
      editable: true,
      subjectEntryType: 0
    },
    watch: {},
    _store: function _store() {
      return BI.Models.getModel("bi.subject.view.extend.report.model", {
        reportType: this.options.reportType
      });
    },
    beforeInit: function beforeInit(callback) {
      this.store.initData(callback);
    },
    render: function render() {
      var self = this;
      var o = this.options;
      return {
        type: "bi.absolute",
        items: [{
          el: {
            type: "bi.left_right_vertical_adapt",
            ref: function ref(_ref) {
              self.toolContainer = _ref;
            },
            cls: "bi-border-bottom",
            height: 25,
            items: self._createToolsItems()
          },
          left: 10,
          right: 10,
          top: 5,
          height: 25
        }, {
          el: {
            type: "bi.vertical",
            items: [{
              type: "bi.iframe",
              src: self.model.src,
              ref: function ref(_ref) {
                self.iframe = _ref;
              }
            }]
            /*type: "bi.label",
            text: self.model.newId*/
          },
          left: 10,
          right: 10,
          top: 30,
          bottom: 0
        }]
      };
    },
    mounted: function mounted() {},
    _createRightItem: function _createRightItem() {
      var self = this;
      var editable = this.options.editable;
      var subjectEntryType = this.options.subjectEntryType;
      editable = editable && subjectEntryType == 0;
      var rightItems = BI.deepClone(BI.Providers.getProvider("bi.provider.dashboard_toolbar").getRightItems(self.model.id));
      rightItems = BI.map(rightItems, function (index, item) {
        /*var cptId = self.model.subjectInfo.id + "/" + self.model.id;
        if (item.text === "公共链接") {
            cptId = self.model.subjectInfo.id + "_@_" + self.model.id;
        }*/
        return {
          el: BI.extend(item, {
            type: "bi.icon_text_item",
            height: 25,
            extraCls: "bi-list-item",
            invisible: function invisible() {
              return !self._isShow(item.value, self.model.reportItem);
            },
            reportInfoGetter: function reportInfoGetter() {
              return {
                id: self.model.id,
                name: self.model.name
              };
            },
            isOwn: true,
            refresh: function refresh() {
              self.refresh(item.value);
              //  self.toolContainer.populate(self._createToolsItems())
            }
          }),

          rgap: RGAP
        };
      });
      return BI.concat(rightItems, [{
        el: {
          type: "bi.icon_text_item",
          cls: "refresh-font",
          extraCls: "bi-list-item",
          height: 25,
          text: "刷新",
          handler: function handler() {
            self.iframe.setSrc(self.model.src);
            //  self.iframe.reset();
          }
        },

        rgap: RGAP
      }, {
        el: {
          type: "bi.icon_text_item",
          cls: "widget-edit-liner-font",
          extraCls: "bi-list-item",
          invisible: !editable,
          height: 25,
          text: "打开设计器编辑",
          handler: function handler() {
            var service = BI.Services.getService("subject.report.service");
            service.openDesigner(function (res) {
              if (res.errorCode) {
                BI.Msg.toast(res.errorMsg, {
                  level: "error"
                });
                return;
              } else {
                var token = res.data;
              }
              var url = window.location.origin + Dec.fineServletURL + "?" + "GWToken" + "?" + token + "?" + self.model.id;
              url = "finereport://" + encodeURIComponent(url);
              try {
                BI.CLI.compatible.remoteDesign(url, {
                  web_ip: BI.CLI.info.ip
                }, self.model.subjectInfo.id);
              } catch (e) {
                window.open(url);
              }
            });
          }
        },
        rgap: RGAP
      }]);
    },
    _createToolsItems: function _createToolsItems() {
      var self = this;
      return {
        left: [{
          type: "bi.label",
          text: "",
          //  css: {"font-size": "large"},
          height: 25
        }],
        right: self._createRightItem()
      };
    },
    _isShow: function _isShow(itemValue, reportItem) {
      var self = this;
      if (itemValue === "publish") {
        return reportItem.publishStatus == 0;
      }
      if (itemValue === "cancel_publish") {
        return reportItem.publishStatus != 0;
      }
      return true;
    },
    refresh: function refresh(itemValue) {
      if (itemValue === "publish" || itemValue === "cancel_publish") {
        this.store.refresh();
      }
    }
  });
  BI.shortcut("bi.subject.view.extend.report", BI.CPTVIEW);
}();
;
!function () {
  var store = BI.inherit(Fix.Model, {
    state: function state() {
      var params = BI.Router.$router.history.current.params;
      return {
        id: params.id,
        op: "page",
        reportType: this.options.reportType
      };
    },
    context: ['subjectInfo', 'tables', 'resourceOperationInfo', 'refreshList'],
    childContext: [],
    computed: {
      reportItem: function reportItem() {
        var self = this;
        var result = {};
        var reportItems = [];
        if (self.model.reportType === "cpt") {
          reportItems = self.model.subjectInfo.cptItems.availableReports;
        } else if (self.model.reportType === "frm") {
          reportItems = self.model.subjectInfo.frmItems.availableReports;
        }
        return BI.find(reportItems, function (index, item) {
          return item.id === self.model.id;
        });
      },
      name: function name() {
        if (this.model.reportItem) {
          return this.model.reportItem.name;
        }
        return "";
      },
      src: function src() {
        var self = this;
        var config = BI.find(BI.Front.SUPPORT_REPORT, function (index, item) {
          return item.type === self.model.reportType;
        });
        if (config) {
          if (self.model.reportType === "cpt") {
            return Dec.fineServletURL + "/view/report?" + "viewlet=" + self.model.id;
          } else if (self.model.reportType === "frm") {
            return Dec.fineServletURL + "/view/form?" + "viewlet=" + self.model.id;
          }
        }
        return Dec.fineServletURL;
      }
    },
    actions: {
      initData: function initData(callback) {
        var self = this;
        BI.isFunction(callback) && callback();
      },
      refresh: function refresh() {
        this.model.refreshList++;
      }
    }
  });
  BI.model("bi.subject.view.extend.report.model", store);
}();
;
!function () {
  function importResource(path, type) {
    var url = Dec.fineServletURL + "/file?path=" + path;
    BI.$import(url, type);
  }
  var perentRoute = BI.find(BI.AnalysisRoutes, function (index, item) {
    return item.name === "analysis_subject";
  });
  if (perentRoute.children) {
    BI.each(BI.Front.SUPPORT_REPORT, function (index, item) {
      perentRoute.children.push(item.route.view);
    });
  }

  //ezreal:协助开发的,后续删
  BI.Plugin.config(function (type, options) {}, function (type, object) {
    object.element.attr("shortcut", object.options.type);
  });
}();
;
!function () {
  BI.Plugin.registerWidget("bi.branch_map", function (widget) {
    if (BI.isFunction(widget.contentGetter)) {
      var oldcontentGetter = widget.contentGetter;
      widget.contentGetter = function (ob) {
        var result = oldcontentGetter.apply(this, arguments);
        var itemType = ob.itemType;
        var find = BI.find(BI.Front.SUPPORT_REPORT, function (index, item) {
          return itemType === item.typeValue;
        });
        if (find && result.listeners) {
          var jumpAction = BI.find(result.listeners, function (i, o) {
            return o.eventName === "EVENT_JUMP";
          });
          if (jumpAction) {
            jumpAction.action = function () {
              //ezreal:当前路由的方式判断下是怎么打开吧。
              var currentRoute = BI.Router.$router.currentRoute;
              if (currentRoute && currentRoute.name == "subject_table") {
                BI.Front.showReportPage(ob.value.id, find.type);
              } else {
                var url = Dec.fineServletURL + "/v5/conf/subject/page/edit/" + ob.value.parentId + "/" + find.type + "/" + ob.value.id;
                window.open(url);
              }
            };
          }
        }
        return result;
      };
    }
    return widget;
  });
}();
;
!function () {
  BI.Plugin.registerWidget("bi.conf.pack.table.usage", function (widget) {
    widget.beforeInit = function (callback) {
      var self = this;
      self.store.cptMap = {};
      self.store.frmMap = {};
      /**
       * 初始化一些数据的
       * @type {self.store.buildItemMap}
       */
      self.store.oldBuildItemMap = self.store.buildItemMap;
      self.store.buildItemMap = function (usageInfo) {
        self.store.oldBuildItemMap(usageInfo);
        BI.each(usageInfo.cptMap, function (key, value) {
          self.store.cptMap[key] = value;
        });
        BI.each(usageInfo.frmMap, function (key, value) {
          self.store.frmMap[key] = value;
        });
      };
      /**
       * 创建节点
       * @type {function(*=, *=, *=): (*|null)}
       */
      self.store.oldGetNodeByItem = self.store.getNodeByItem;
      self.store.getNodeByItem = function (pId, item, direction) {
        var find = BI.find(BI.Front.SUPPORT_REPORT, function (index, o) {
          return item.type === o.typeValue;
        });
        if (find) {
          var info = {
            isParent: item.knots > 0,
            count: item.knots,
            childrenItems: item.usageItemBeans,
            direction: direction
          };
          var reportMap = {};
          if (find.typeValue === 101) {
            reportMap = self.store.cptMap;
          } else if (find.typeValue === 102) {
            reportMap = self.store.frmMap;
          }
          if (reportMap[item.id]) {
            return BI.extend(self.store.createExtendReportNode(pId, reportMap[item.id], find.typeValue, reportMap), info);
          }
          return null;
        }
        return self.store.oldGetNodeByItem(pId, item, direction);
      };
      self.store.createExtendReportNode = function (pId, report, itemType, reportMap) {
        return {
          text: report.name,
          title: function title() {
            if (BI.isNotNull(reportMap[report.id].position)) {
              return Promise.resolve(getReportDescription(reportMap[report.id]));
            }
            return getExtendReportInfo(report.id, itemType).then(function (res) {
              var _res$data = res.data,
                position = _res$data.position,
                createBy = _res$data.createBy,
                createTime = _res$data.createTime,
                lastUpdateTime = _res$data.lastUpdateTime;
              reportMap[report.id] = Object.assign(Object.assign({}, report), {
                position: position,
                createBy: createBy,
                createTime: createTime,
                lastUpdateTime: lastUpdateTime
              });
              return getReportDescription(reportMap[report.id]);
            });
          },
          value: Object.assign(Object.assign({}, report), {
            moduleType: 2
          }),
          id: BI.UUID(),
          pId: pId,
          itemType: itemType
        };
      };
      function getExtendReportInfo(id, type) {
        var url = "/v5/conf/tables/usage/info";
        var data = {
          id: id,
          type: type
        };
        return new Promise(function (resolve) {
          Dec.reqPost(url, data, function (res) {
            resolve(res);
          });
        });
      }
      function getReportDescription(report) {
        var description = [];
        description.push("报表名称:" + report.name);
        description.push(BI.i18nText('BI-Conf_Position_With_Colon') + report.position);
        description.push(BI.i18nText('BI-Basic_Creator_Colon') + report.createBy);
        report.createTime && description.push(BI.i18nText('BI-Basic_Creator_Time_Colon') + BI.print(BI.getDate(report.createTime), '%Y/%X/%d %H:%M:%S'));
        report.lastUpdateTime && description.push(BI.i18nText('BI-Conf_Last_Edit_Time') + BI.print(BI.getDate(report.lastUpdateTime), '%Y/%X/%d %H:%M:%S'));
        return description.join('\n');
      }

      /**
       * 图标
       * @type {function(*=): (*)}
       */
      self.oldGetIconCls = self.getIconCls;
      self.getIconCls = function (ob) {
        var find = BI.find(BI.Front.SUPPORT_REPORT, function (index, o) {
          return ob.itemType === o.typeValue;
        });
        if (find) {
          return find.iconCls;
        }
        return self.oldGetIconCls(ob);
      };
      BI.isFunction(callback) && callback();
    };
    return widget;
  });
  BI.Plugin.configRender("bi.conf.pack.table.usage", function (renderObject) {
    return renderObject;
  });
}();
;
!function () {
  BI.Plugin.registerWidget("dec.bi_publish.filter", function (widget) {
    widget.beforeCreate = function () {
      var self = this;
      self.oldCreateTypeFilter = self.createTypeFilter;
      self.createTypeFilter = function () {
        var result = self.oldCreateTypeFilter();
        var chooser = result.items[1];
        var x = chooser.el || chooser;
        var items = BI.deepClone(x.items);
        BI.each(BI.Front.SUPPORT_REPORT, function (index, o) {
          items.push({
            value: o.typeValue,
            text: o.text
          });
        });
        x.items = items;
        return result;
      };
    };
    return widget;
  });
}();
;
!function () {
  function getStatusIconCls(status) {
    switch (status) {
      case 1:
        //申请发布
        return 'resource-publish-font';
      case 3:
        //已发布
        return 'resource-published-font';
      default:
        return 'resource-cancel-publish-font';
    }
  }
  function getStatus(status) {
    switch (status) {
      case 1:
        //申请发布
        return BI.i18nText('Dec-BI_Apply_Publish');
      case 2:
        //取消发布
        return BI.i18nText('Dec-BI_Apply_Cancel_Publish');
      case 3: //已发布
      default:
        return BI.i18nText('Dec-BI_Apply_Published');
    }
  }
  function getFormatTime(timeStamp) {
    return BI.getDate(timeStamp).print('%Y-%X-%d %H:%M:%S');
  }
  BI.Plugin.registerWidget("dec.management.bi_publish.list.item", function (widget) {
    var x = BI.find(BI.Front.SUPPORT_REPORT, function (index, item) {
      return item.typeValue === widget.itemType;
    });
    if (x) {
      widget.oldItemType = widget.itemType;
      widget.itemType = 1; //部分逻辑按照仪表板处理
      widget.reportType = x;
      /*
      BI.each(widget.listeners, function (index, item) {
          if (item.eventName === "EVENT_PREVIEW") {
              item.oldAction = item.action;
              item.action = function () {
                  /!*                        const dialog = BI.createTopIframe(BI.UUID(), {
                                              isFullScreen: false,
                                              header: widget.name,
                                          });
                                          var url = Dec.fineServletURL;
                                          if (x.type === "cpt") {
                                              url = Dec.fineServletURL + "/view/report?" + "viewlet=" + widget.itemId;
                                          } else if (x.type === "frm") {
                                              url = Dec.fineServletURL + "/view/form?" + "viewlet=" + widget.itemId;
                                          }
                                          dialog.setSrc(url);*!/
              }
          }
      })*/
      //不好处理，只能单独写这个的render函数，来改一些逻辑
      widget.render = function () {
        var self = this;
        var _this$options3 = this.options,
          itemType = _this$options3.itemType,
          publishStatus = _this$options3.publishStatus,
          applyTime = _this$options3.applyTime,
          itemId = _this$options3.itemId,
          name = _this$options3.name,
          username = _this$options3.username,
          department = _this$options3.department,
          role = _this$options3.role;
        return {
          type: "bi.htape",
          cls: "bi-border-bottom",
          height: 32,
          items: [{
            type: "bi.htape",
            columnSize: ['fill', 0.2, 0.2, 0.2, 0.2],
            items: [{
              el: {
                type: "bi.htape",
                items: [{
                  el: {
                    type: "bi.icon_label",
                    cls: x.iconCls,
                    height: 32,
                    width: 16,
                    iconHeight: 16,
                    iconWidth: 16
                  },
                  width: 16,
                  lgap: 8
                }, {
                  el: {
                    type: "bi.label",
                    height: 32,
                    whiteSpace: "nowrap",
                    textAlign: "left",
                    text: name,
                    title: name
                  },
                  width: "fill",
                  lgap: 8
                }]
              },
              lgap: 10
            },
            /*                                {
                                                el: {
                                                    type: "bi.icon_text_item",
                                                    height: 16,
                                                    width: 16,
                                                    iconWidth: 16,
                                                    iconHeight: 16,
                                                    whiteSpace: "nowrap",
                                                    text: name,
                                                    title: name,
                                                    cls: x.iconCls
                                                }, lgap: 10
                                            },*/
            {
              el: {
                type: "bi.icon_text_item",
                iconWrapperWidth: 24,
                iconCls: getStatusIconCls(publishStatus),
                text: getStatus(publishStatus),
                title: getStatus(publishStatus)
              }
            }, {
              el: self.createLabel(username)
            }, {
              el: self.createLabel(department)
            }, {
              el: self.createLabel(role)
            }]
          }, {
            type: "bi.label",
            width: 130,
            textAlign: "left",
            text: getFormatTime(applyTime),
            title: getFormatTime(applyTime)
          }, {
            type: "bi.vertical_adapt",
            width: 100,
            items: [{
              type: "bi.text_button",
              rgap: 10,
              cls: "bi-high-light",
              text: BI.i18nText('Dec-Basic_Preview'),
              handler: function handler() {
                var dialog = BI.createTopIframe(BI.UUID(), {
                  isFullScreen: false,
                  header: widget.name
                });
                var url = Dec.fineServletURL;
                if (x.type === "cpt") {
                  url = Dec.fineServletURL + "/view/report?" + "viewlet=" + widget.itemId;
                } else if (x.type === "frm") {
                  url = Dec.fineServletURL + "/view/form?" + "viewlet=" + widget.itemId;
                }
                dialog.setSrc(url);
                self.fireEvent("EVENT_PREVIEW", itemType);
              }
            }, {
              type: "bi.text_button",
              cls: "bi-high-light",
              text: BI.i18nText('Dec-BI_Apply_Deal'),
              handler: function handler() {
                self.openDealPopover();
                self.fireEvent("EVENT_DEAL", itemType, publishStatus);
              }
            }]
          }]
        };
      };
    }
    return widget;
  });
}();