;!(function () {
    function getStatusIconCls(status) {
        switch (status) {
            case 1://申请发布
                return 'resource-publish-font';
            case 3://已发布
                return 'resource-published-font';
            default:
                return 'resource-cancel-publish-font';
        }
    }

    function getStatus(status) {
        switch (status) {
            case 1://申请发布
                return BI.i18nText('Dec-BI_Apply_Publish');
            case 2://取消发布
                return BI.i18nText('Dec-BI_Apply_Cancel_Publish');
            case 3://已发布
            default:
                return BI.i18nText('Dec-BI_Apply_Published');
        }
    }

    function getFormatTime(timeStamp) {
        return BI.getDate(timeStamp).print('%Y-%X-%d %H:%M:%S');
    }

    BI.Plugin.registerWidget("dec.management.bi_publish.list.item", function (widget) {
        var x = BI.find(BI.Front.SUPPORT_REPORT, function (index, item) {
            return item.typeValue === widget.itemType;
        })
        if (x) {
            widget.oldItemType = widget.itemType;
            widget.itemType = 1;//部分逻辑按照仪表板处理
            widget.reportType = x;
            /*
            BI.each(widget.listeners, function (index, item) {
                if (item.eventName === "EVENT_PREVIEW") {
                    item.oldAction = item.action;
                    item.action = function () {
                        /!*                        const dialog = BI.createTopIframe(BI.UUID(), {
                                                    isFullScreen: false,
                                                    header: widget.name,
                                                });
                                                var url = Dec.fineServletURL;
                                                if (x.type === "cpt") {
                                                    url = Dec.fineServletURL + "/view/report?" + "viewlet=" + widget.itemId;
                                                } else if (x.type === "frm") {
                                                    url = Dec.fineServletURL + "/view/form?" + "viewlet=" + widget.itemId;
                                                }
                                                dialog.setSrc(url);*!/
                    }
                }
            })*/
            //不好处理，只能单独写这个的render函数，来改一些逻辑
            widget.render = function () {
                var self = this;
                const {itemType, publishStatus, applyTime, itemId, name, username, department, role} = this.options;
                return {
                    type: "bi.htape",
                    cls: "bi-border-bottom",
                    height: 32,
                    items: [
                        {
                            type: "bi.htape",
                            columnSize: ['fill', 0.2, 0.2, 0.2, 0.2],
                            items: [
                                {
                                    el: {
                                        type: "bi.htape",
                                        items: [
                                            {
                                                el: {
                                                    type: "bi.icon_label",
                                                    cls: x.iconCls,
                                                    height: 32,
                                                    width: 16,
                                                    iconHeight: 16,
                                                    iconWidth: 16,
                                                }, width: 16, lgap: 8
                                            }, {
                                                el: {
                                                    type: "bi.label",
                                                    height: 32,
                                                    whiteSpace: "nowrap",
                                                    textAlign: "left",
                                                    text: name,
                                                    title: name,
                                                }, width: "fill", lgap: 8
                                            }
                                        ]
                                    }, lgap: 10
                                },
                                /*                                {
                                                                    el: {
                                                                        type: "bi.icon_text_item",
                                                                        height: 16,
                                                                        width: 16,
                                                                        iconWidth: 16,
                                                                        iconHeight: 16,
                                                                        whiteSpace: "nowrap",
                                                                        text: name,
                                                                        title: name,
                                                                        cls: x.iconCls
                                                                    }, lgap: 10
                                                                },*/
                                {
                                    el: {
                                        type: "bi.icon_text_item",
                                        iconWrapperWidth: 24,
                                        iconCls: getStatusIconCls(publishStatus),
                                        text: getStatus(publishStatus),
                                        title: getStatus(publishStatus)
                                    }
                                },
                                {
                                    el: self.createLabel(username)
                                },
                                {
                                    el: self.createLabel(department)
                                },
                                {
                                    el: self.createLabel(role)
                                }
                            ]
                        },
                        {
                            type: "bi.label",
                            width: 130,
                            textAlign: "left",
                            text: getFormatTime(applyTime),
                            title: getFormatTime(applyTime)
                        },
                        {
                            type: "bi.vertical_adapt",
                            width: 100,
                            items: [
                                {
                                    type: "bi.text_button",
                                    rgap: 10,
                                    cls: "bi-high-light",
                                    text: BI.i18nText('Dec-Basic_Preview'),
                                    handler: function () {
                                        const dialog = BI.createTopIframe(BI.UUID(), {
                                            isFullScreen: false,
                                            header: widget.name,
                                        });
                                        var url = Dec.fineServletURL;
                                        if (x.type === "cpt") {
                                            url = Dec.fineServletURL + "/view/report?" + "viewlet=" + widget.itemId;
                                        } else if (x.type === "frm") {
                                            url = Dec.fineServletURL + "/view/form?" + "viewlet=" + widget.itemId;
                                        }
                                        dialog.setSrc(url);
                                        self.fireEvent("EVENT_PREVIEW", itemType);
                                    }
                                },
                                {
                                    type: "bi.text_button",
                                    cls: "bi-high-light",
                                    text: BI.i18nText('Dec-BI_Apply_Deal'),
                                    handler: function () {
                                        self.openDealPopover();
                                        self.fireEvent("EVENT_DEAL", itemType, publishStatus);
                                    }
                                }
                            ]
                        }
                    ]
                }

            }
        }
        return widget;
    });
})();