/**
 * 对bi.subject.view组件的一些魔改
 */
;!(function () {
    BI.Front = BI.Front || {};
    BI.Front = BI.extend(BI.Front, {
        subject_view: {
            store: null,
            model: null,
        }
    });
    BI.Plugin.registerWidget("bi.subject.view", function (widget) {
        widget.beforeInit = function (callback) {
            var self = this;
            var service = BI.Services.getService("subject.report.service");
            BI.Front.subject_view.store = self.store;
            BI.Front.subject_view.model = self.model;
            self.store.getExtendReportItem = function (item, type) {
                var find = BI.find(BI.Front.SUPPORT_REPORT, function (index, o) {
                    return o.type === type || o.typeValue === type;
                })
                if (find) {
                    return {
                        type: find.paneType.tab,
                        id: item.id,
                        name: item.name,
                        report: item,
                        reportType: find.type,
                        iconCls: find.iconCls,
                        onSelect: function () {
                            BI.Front.showReportPage(item.id, find.type)
                        },
                        listeners: [
                            {
                                eventName: "DELETE",
                                action: function (id) {
                                    self.store.deleteExtendReport(id);
                                }
                            },
                            {
                                eventName: "EVENT_REFRESH",
                                action: function () {
                                    self.store.refreshTab()
                                }
                            }
                        ],
                        editable: self.options.subjectEntryType == 0
                    }
                }
                return {
                    type: "bi.label",
                    text: item.name
                }
            }
            self.store.addExtendReport = function (data) {
                service.subjectAddReport(BI.Router.$router.history.current.params.subjectId, data, function (res) {
                    if (res.data) {
                        const order = self.model.customOrder.slice();
                        order.push(res.data.id);
                        self.store.sortLabels(order).then(function () {
                            self.store.refreshTab().then(function () {
                                BI.Front.showReportPage(res.data.id, data.type);
                            })
                        });
                    } else if (res.errorCode) {
                        BI.Msg.toast(res.errorMsg, {level: "error"});
                    }
                })
            }
            self.store.deleteExtendReport = function (id) {
                service.deleteSubjectReport(self.model.subjectInfo.id, id, function (res) {
                    if (res.data && res.data.errorCode) {
                        if (res.data.errorCode == "61600003") {
                            BI.Msg.toast("已发布模板无法删除", {level: "error"});
                        } else {
                            BI.Msg.toast("删除报错", {level: "error"});
                        }
                        return;
                    }
                    self.store.refreshTab(id);
                })
            }
            self.store.checkReportName = function (value) {
                var self = this;
                var reportItems = [];
                if (value.type === 101) {
                    reportItems = self.model.subjectInfo.cptItems.availableReports
                } else if (value.type === 102) {
                    reportItems = self.model.subjectInfo.frmItems.availableReports
                }
                var find = BI.find(reportItems, function (i, item) {
                    return item.name == value.name;
                })
                if (find) {
                    BI.Msg.toast("同类报表名称不能重复", {level: "error"});
                    return false;
                }
                return true;
            }
            /*            /!**
                         * 初始化
                         *!/
                        BI.each(self.model.subjectInfo.cptItems.availableReports, function (index, o) {
                            self.model.labels.push(self.store.getExtendReportItem(o, "cpt"));
                        });
                        BI.each(self.model.subjectInfo.frmItems.availableReports, function (index, o) {
                            self.model.labels.push(self.store.getExtendReportItem(o, "frm"));
                        });
                        const order = self.model.customOrder;
                        if (BI.isEmptyArray(order)) {
                            self.model.sortLabels = self.model.labels;
                        } else {
                            self.model.sortLabels = self.model.labels.sort(function (a, b) {
                                return order.indexOf(a.id) - order.indexOf(b.id);
                            })
                        }*/
            BI.Front.utils.injectionFunc(self.store._computedWatchers.labels, [
                {
                    functionName: "getter",
                    returnValue: true,
                    afterFunc: function (oldLabel) {
                        BI.each(self.model.subjectInfo.cptItems.availableReports, function (index, o) {
                            var find = BI.find(oldLabel, function (i, label) {
                                return o.id === label.id;
                            })
                            if (!find) {
                                oldLabel.push(self.store.getExtendReportItem(o, "cpt"));
                            }
                        });
                        BI.each(self.model.subjectInfo.frmItems.availableReports, function (index, o) {
                            var find = BI.find(oldLabel, function (i, label) {
                                return o.id === label.id;
                            })
                            if (!find) {
                                oldLabel.push(self.store.getExtendReportItem(o, "frm"));
                            }
                        });
                        return oldLabel;
                    }
                }
            ])
            BI.Front.utils.injectionFunc(self.store, [
                {
                    functionName: "refreshTab",
                    afterFunc: function (value, id) {
                        if (BI.isNotNull(id)) {
                            return this.updateSubjectInfo();
                        }
                        return value;
                    },
                    returnValue: true
                }
            ]);
            // self.store.updateSubjectInfo();
            BI.isFunction(callback) && callback();
        }
    });
})();