/**
 * 展示cpt模板
 */
;!(function () {
    var RGAP = 15;
    BI.CPTVIEW = BI.inherit(BI.Widget, {
        props: {
            reportType: "cpt",
            editable: true,
            subjectEntryType: 0
        },
        watch: {},
        _store: function () {
            return BI.Models.getModel("bi.subject.view.extend.report.model", {
                reportType: this.options.reportType
            });
        },
        beforeInit: function (callback) {
            this.store.initData(callback);
        },
        render: function () {
            var self = this;
            var o = this.options;
            return {
                type: "bi.absolute",
                items: [
                    {
                        el: {
                            type: "bi.left_right_vertical_adapt",
                            ref: function (_ref) {
                                self.toolContainer = _ref;
                            },
                            cls: "bi-border-bottom",
                            height: 25,
                            items: self._createToolsItems()
                        }, left: 10, right: 10, top: 5, height: 25
                    },
                    {
                        el: {
                            type: "bi.vertical",
                            items: [{
                                type: "bi.iframe",
                                src: self.model.src,
                                ref: function (_ref) {
                                    self.iframe = _ref;
                                }
                            }]
                            /*type: "bi.label",
                            text: self.model.newId*/
                        }, left: 10, right: 10, top: 30, bottom: 0
                    }
                ]
            }


        },
        mounted: function () {

        },
        _createRightItem: function () {
            var self = this;
            var editable = this.options.editable;
            var subjectEntryType = this.options.subjectEntryType;
            editable = editable && (subjectEntryType == 0);
            let rightItems = BI.deepClone(BI.Providers.getProvider("bi.provider.dashboard_toolbar").getRightItems(self.model.id));
            rightItems = BI.map(rightItems, function (index, item) {
                /*var cptId = self.model.subjectInfo.id + "/" + self.model.id;
                if (item.text === "公共链接") {
                    cptId = self.model.subjectInfo.id + "_@_" + self.model.id;
                }*/
                return {
                    el: BI.extend(item, {
                        type: "bi.icon_text_item",
                        height: 25,
                        extraCls: "bi-list-item",
                        invisible: function () {
                            return !self._isShow(item.value, self.model.reportItem);
                        },
                        reportInfoGetter: function () {
                            return {
                                id: self.model.id,
                                name: self.model.name
                            }
                        },
                        isOwn: true,
                        refresh: function () {
                            self.refresh(item.value);
                            //  self.toolContainer.populate(self._createToolsItems())
                        }
                    }), rgap: RGAP
                }
            });
            return BI.concat(rightItems, [
                {
                    el: {
                        type: "bi.icon_text_item",
                        cls: "refresh-font",
                        extraCls: "bi-list-item",
                        height: 25,
                        text: "刷新",
                        handler: function () {
                            self.iframe.setSrc(self.model.src);
                            //  self.iframe.reset();
                        }
                    }, rgap: RGAP
                },
                {
                    el: {
                        type: "bi.icon_text_item",
                        cls: "widget-edit-liner-font",
                        extraCls: "bi-list-item",
                        invisible: !editable,
                        height: 25,
                        text: "打开设计器编辑",
                        handler: function () {
                            var service = BI.Services.getService("subject.report.service");
                            service.openDesigner(function (res) {
                                if (res.errorCode) {
                                    BI.Msg.toast(res.errorMsg, {level: "error"});
                                    return;
                                } else {
                                    var token = res.data;
                                }
                                var url = window.location.origin + Dec.fineServletURL + "?" + "GWToken" + "?" + token + "?" + self.model.id;
                                url = "finereport://" + encodeURIComponent(url);
                                try {
                                    BI.CLI.compatible.remoteDesign(url,{web_ip : BI.CLI.info.ip},self.model.subjectInfo.id);
                                } catch (e) {
                                    window.open(url);
                                }
                            });


                        }
                    }, rgap: RGAP
                }
            ])
        },
        _createToolsItems: function () {
            var self = this;
            return {
                left: [
                    {
                        type: "bi.label",
                        text: "",
                        //  css: {"font-size": "large"},
                        height: 25
                    }
                ],
                right: self._createRightItem()
            }

        },
        _isShow: function (itemValue, reportItem) {
            var self = this;
            if (itemValue === "publish") {
                return reportItem.publishStatus == 0;
            }
            if (itemValue === "cancel_publish") {
                return reportItem.publishStatus != 0;
            }
            return true;
        },
        refresh: function (itemValue) {
            if (itemValue === "publish" || itemValue === "cancel_publish") {
                this.store.refresh();
            }
        }
    });
    BI.shortcut("bi.subject.view.extend.report", BI.CPTVIEW);

})();