;!(function () {
    var store = BI.inherit(Fix.Model, {
        state: function () {
            const {params} = BI.Router.$router.history.current;
            return {
                id: params.id,
                op: "page",
                reportType: this.options.reportType
            }
        },
        context: ['subjectInfo', 'tables', 'resourceOperationInfo', 'refreshList'],
        childContext: [],
        computed: {
            reportItem: function () {
                var self = this;
                var result = {};
                var reportItems = [];
                if (self.model.reportType === "cpt") {
                    reportItems = self.model.subjectInfo.cptItems.availableReports
                } else if (self.model.reportType === "frm") {
                    reportItems = self.model.subjectInfo.frmItems.availableReports
                }
                return BI.find(reportItems, function (index, item) {
                    return item.id === self.model.id;
                });
            },
            name: function () {
                if (this.model.reportItem) {
                    return this.model.reportItem.name;
                }
                return "";
            },
            src: function () {
                var self = this;
                var config = BI.find(BI.Front.SUPPORT_REPORT, function (index, item) {
                    return item.type === self.model.reportType
                })
                if (config) {
                    if (self.model.reportType === "cpt") {
                        return Dec.fineServletURL + "/view/report?" + "viewlet=" + self.model.id;
                    } else if (self.model.reportType === "frm") {
                        return Dec.fineServletURL + "/view/form?" + "viewlet=" + self.model.id;
                    }
                }
                return Dec.fineServletURL;
            }
        },
        actions: {
            initData: function (callback) {
                var self = this;

                BI.isFunction(callback) && callback()
            },
            refresh: function () {
                this.model.refreshList++;
            }
        }
    });
    BI.model("bi.subject.view.extend.report.model", store);
})();