;!(function () {
    BI.Plugin.registerWidget("bi.conf.pack.table.usage", function (widget) {
        widget.beforeInit = function (callback) {
            var self = this;
            self.store.cptMap = {};
            self.store.frmMap = {};
            /**
             * 初始化一些数据的
             * @type {self.store.buildItemMap}
             */
            self.store.oldBuildItemMap = self.store.buildItemMap;
            self.store.buildItemMap = function (usageInfo) {
                self.store.oldBuildItemMap(usageInfo);
                BI.each(usageInfo.cptMap, (key, value) => {
                    self.store.cptMap[key] = value;
                });
                BI.each(usageInfo.frmMap, (key, value) => {
                    self.store.frmMap[key] = value;
                });
            }
            /**
             * 创建节点
             * @type {function(*=, *=, *=): (*|null)}
             */
            self.store.oldGetNodeByItem = self.store.getNodeByItem;
            self.store.getNodeByItem = function (pId, item, direction) {
                var find = BI.find(BI.Front.SUPPORT_REPORT, function (index, o) {
                    return item.type === o.typeValue;
                })
                if (find) {
                    var info = {
                        isParent: item.knots > 0,
                        count: item.knots,
                        childrenItems: item.usageItemBeans,
                        direction: direction,
                    };
                    var reportMap = {};
                    if (find.typeValue === 101) {
                        reportMap = self.store.cptMap
                    } else if (find.typeValue === 102) {
                        reportMap = self.store.frmMap
                    }
                    if (reportMap[item.id]) {
                        return BI.extend(self.store.createExtendReportNode(pId, reportMap[item.id], find.typeValue, reportMap), info)
                    }
                    return null;
                }
                return self.store.oldGetNodeByItem(pId, item, direction);
            }
            self.store.createExtendReportNode = function (pId, report, itemType, reportMap) {
                return {
                    text: report.name,
                    title: function () {
                        if (BI.isNotNull(reportMap[report.id].position)) {
                            return Promise.resolve(getReportDescription(reportMap[report.id]));
                        }
                        return getExtendReportInfo(report.id, itemType).then(function (res) {
                            const {position, createBy, createTime, lastUpdateTime} = res.data;
                            reportMap[report.id] = Object.assign(Object.assign({}, report), {
                                position: position,
                                createBy: createBy,
                                createTime: createTime,
                                lastUpdateTime: lastUpdateTime
                            });
                            return getReportDescription(reportMap[report.id]);
                        });
                    },
                    value: Object.assign(Object.assign({}, report), {moduleType: 2}),
                    id: BI.UUID(),
                    pId: pId,
                    itemType: itemType,
                }
            }

            function getExtendReportInfo(id, type) {
                var url = "/v5/conf/tables/usage/info";
                var data = {
                    id: id,
                    type: type
                }
                return new Promise(function (resolve) {
                    Dec.reqPost(url, data, function (res) {
                        resolve(res);
                    })
                })
            }

            function getReportDescription(report) {
                var description = [];
                description.push("报表名称:" + report.name);
                description.push(BI.i18nText('BI-Conf_Position_With_Colon') + report.position);
                description.push(BI.i18nText('BI-Basic_Creator_Colon') + report.createBy);
                report.createTime &&
                description.push(
                    BI.i18nText('BI-Basic_Creator_Time_Colon') + BI.print(BI.getDate(report.createTime), '%Y/%X/%d %H:%M:%S')
                );
                report.lastUpdateTime &&
                description.push(
                    BI.i18nText('BI-Conf_Last_Edit_Time') + BI.print(BI.getDate(report.lastUpdateTime), '%Y/%X/%d %H:%M:%S')
                );

                return description.join('\n');
            }

            /**
             * 图标
             * @type {function(*=): (*)}
             */
            self.oldGetIconCls = self.getIconCls;
            self.getIconCls = function (ob) {
                var find = BI.find(BI.Front.SUPPORT_REPORT, function (index, o) {
                    return ob.itemType === o.typeValue;
                });
                if (find) {
                    return find.iconCls;
                }
                return self.oldGetIconCls(ob)
            }


            BI.isFunction(callback) && callback();

        };
        return widget;
    });
    BI.Plugin.configRender("bi.conf.pack.table.usage", function (renderObject) {
        return renderObject;
    })
})();